<?php

App::uses('AppController', 'Controller');

class AdminsController extends AppController {

    public $uses = array('User','Dealer','Zone','Area','Pincode','Territory','District');
    public $helper = array('Html', 'Session');
    public $components = array('Session', 'Flash','CommonCmp');
    public $logintype = '';
    public $userid = '';

    public function beforeFilter() {
        parent::beforeFilter();
        $this->logintype = $this->Session->read('logintype');
        $this->userid = $this->Session->read('user_id');
    }

    public function login() {
        $this->set('title_for_layout', 'Administrator || Login');
        if ($this->logintype != ''){
            if($this->logintype == 'ADMIN') {       
                $this->redirect(array('controller' => 'admins', 'action' => 'dashboard'));
            } else {
                $this->Flash->warning(PERMISSION_DENIDE);
                $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
            }
        }
    }

    public function checklogin() {
        $this->layout = false;
        if (!empty($this->request->data)) {
            $admindata = $this->User->find('first', array(
                'conditions' => array(
                    'User.name' => $this->request->data['User']['username'],
                    'User.password' => base64_encode($this->request->data['User']['password'])
                ),
                'fields' => array('id', 'email', 'name','designation')
            ));
            if (!empty($admindata)) {
                $this->Session->write('admindata', $admindata);
                $logintype = strtoupper($admindata['User']['designation']);
                $this->Session->write('logintype',$logintype);
                $this->Session->write('shortname', 'Admin');
                $this->Session->write('user_id', $admindata['User']['id']);
                $this->Flash->success('You have logged in successfully');
                $this->redirect('login');
            } else {
                $this->Flash->error('Invalid Username or password.');
                $this->redirect('login');
            }
        } else {
            $this->Flash->warning('Please provide your login credentials.');
            $this->redirect('login');
        }
    }

    public function dashboard() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        }else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));                    
        } else {
            $this->set('title_for_layout', 'Welcome Administrator || Dashboard');
            $totalDealers = $this->getCount('Dealer');
            
            $totalZone = $this->getCount('Zone');
            $totalArea = $this->getCount('Area');
            $totalTerritory = $this->getCount('Territory');
            $totalPincode = $this->getCount('Pincode');
            $totalDistrict = $this->getCount('District');
            
            $this->set('totalZone', $totalZone);
            $this->set('totalArea', $totalArea);
            $this->set('totalTerritory', $totalTerritory);
            $this->set('totalPincode', $totalPincode);
            $this->set('totalDealers', $totalDealers);
            $this->set('totalDistrict', $totalDistrict);
            
            /*$zoneData = $this->CommonCmp->commonList('Zone', array('status' => 'true'), array(), array('zone_name' => 'ASC'), $type = 'all');
                        
            $pieChartData = array('Zone'=>'Population');
            $this->set('pieChartData', $zoneData);*/
        }
    }

    public function changepassword() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        }else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $this->set('title_for_layout', 'Administrator || Change Password');
        }
    }

    public function checkpassword() {
        $this->layout = false;
        if (!empty($this->request->data)) {
            $conditions = array(
                'password' => base64_encode($this->request->data['colvalue']),
                'id' => $this->userid
            );
            $checkexist = $this->User->find('count', array(
                'conditions' => $conditions
            ));
            if ($checkexist > 0) {
                echo "MATCHED";
                die;
            } else {
                echo "NOTMATCHED";
                die;
            }
        }
    }

    public function savepassword() {
        if (!empty($this->request->data)) {
            if ($this->request->data['Admin']['newpassword'] == $this->request->data['Admin']['currentpassword']) {
                $this->Flash->error('Current Password and New Password both are same.');
                $this->redirect('changepassword');
            } else if ($this->request->data['Admin']['newpassword'] == $this->request->data['Admin']['confirmpassword']) {
                $conditions = array(
                    'password' => base64_encode($this->request->data['Admin']['currentpassword']),
                    'id' => $this->userid
                );
                $admindata = $this->User->find('first', array('conditions' => $conditions, 'fields' => array('id', 'password')));
                if (!empty($admindata)) {
                    if ($this->User->updateAll(array('password' => "'" . base64_encode($this->request->data['Admin']['newpassword']) . "'"), array('id' => $admindata['User']['id']))) {
                        $this->Flash->success('Password changed successfully.');
                        $this->redirect('changepassword');
                    } else {
                        $this->Flash->error('Please try after sometime.');
                        $this->redirect('changepassword');
                    }
                } else {
                    $this->Flash->error('Invalid Current Password.');
                    $this->redirect('changepassword');
                }
            } else {
                $this->Flash->error('New Password and Confirm Password do not matched.');
                $this->redirect('changepassword');
            }
        }
    }

    public function logout() {
        $this->Session->destroy();
        $this->Flash->notice('You have logged out successfully.');
        $this->redirect(array('controller' => 'users', 'action' => 'login'));
    }

    public function retrievepassword() {       
        if (isset($this->request->data['User']['email'])) {         
            $toemail = $this->request->data['User']['email'];
            $conditions = array(
                'User.email' => $toemail
            );
            $checkexist = $this->User->find('first', array(
                'conditions' => $conditions
            ));
            if (!empty($checkexist)) {
                $name = $checkexist['User']['name'];
                $password = json_decode($checkexist['User']['password']);
                $body = "Hi " . ucfirst($name) . ",<br/><br/><br/>";
                $body .= "You have requested the password for your JSW login.<br/><br/>";
                $body .= "<b>Your Username : </b>" . $name . "<br/>";
                $body .= "<b>Pssword : </b>" . $password . "<br/><br/><br/>";
                $body .= "Thankyou<br/>JSW Support Team";
                $subject = 'Forget password';
                $this->sendEmail($toemail, $subject, $body);
                $this->Flash->success('Your password have been sent to your email address');
                $this->redirect('login');
            } else {
                $this->Flash->notice('This email address is not registered with us.');
                $this->redirect('login');
            }
        } else {
            $this->Flash->notice('Please provide email address');
            $this->redirect('login');
        }
    }
    
    private function getCount($modelName){
        
        $countData = $this->$modelName->find('count');

        $total = 0;
        if(count($countData) > 0){
            
            $total = $countData;
        }
        
        return $total;
        
    }

}
