<?php

App::import('AppController', 'Controller');

class AreasController extends AppController {

    public $name = 'Areas';
    public $uses = array('Area', 'Zone','Pincode');
    public $helper = array('Html', 'Session', 'Paginator');
    public $components = array('Session', 'Paginator', 'Flash','CommonCmp');
    public $paginate = array('limit' => 20, 'order' => array('Area.code' => 'asc'));
    public $user_id = '';
    public $logintype = '';
    public $categoryType = '';

    public function beforeFilter() {
        parent::beforeFilter();
        $this->logintype = $this->Session->read('logintype');
        //$this->categoryType = array('1' => 'Area','2'=>'Rural','3'=>'Territory');
        $this->categoryType = array('3'=>'Territory');
    }

    public function manageareas() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        }else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $this->set('title_for_layout', 'Administrator || Manage Area');
            $conditions = array('Area.type !='=>'3');
            $searchkey = '';
            if (isset($this->request->data['Area']['searchkey']) && ($this->request->data['Area']['searchkey'] != ''))              {
                $searchkey = trim($this->request->data['Area']['searchkey']);
                $conditions['OR'] = array(
                    'Area.district_id LIKE' => "%$searchkey%",
                    'Area.code LIKE' => "%$searchkey%",
                    'Area.name LIKE' => "%$searchkey%"
                );
            }
            $this->paginate['conditions'] = $conditions;
            $this->set('searchkey', $searchkey);
            $this->Paginator->settings = $this->paginate;
            $data = $this->Paginator->paginate('Area');
            $this->set('data', $data);
        }
    }

    public function groupaction() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        }else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $querydata = $this->request->query;
            $statusArr = $this->CommonCmp->groupActions('Area', $querydata);         
            $status = isset($statusArr['status'])?$statusArr['status']:'error';
            $msg = isset($statusArr['msg'])?$statusArr['msg']:'Technical error please try after sometime.';
            $this->Flash->$status($msg);
            $this->redirect($this->referer());
        }
    }
}
