<?php

App::uses('Component', 'Controller');

class ValidationCmpComponent extends Component {

    public function allowMethod($request, $methodType) {
        $isValid = FALSE;
        if ($methodType != '' && $request->is($methodType)) {
            $isValid = TRUE;
        }
        return $isValid;
    }

    public function outputJson($reponsestatus) {

        return json_encode($reponsestatus);
    }

    public function validateParams($requiredParams, $inputData) {
        $missingParams = array();
        foreach ($requiredParams as $field) {
            if (!isset($inputData[$field])) {
                $missingParams[] = $field;
            }
        }
        return $missingParams;
    }

    public function groupActions($model, $dataParams) {
        $modelObj = ClassRegistry::init($model);
        $processStatus = '';
        $msg = '';
        if (!empty($dataParams)) {
            $id = $dataParams['id'];
            if (isset($dataParams['actname']) && ($dataParams['actname'] == 'status')) {
                $status = $dataParams['currentsts'];
                if ($status == 1) {
                    $stsflg = 'false';
                } else {
                    $stsflg = 'true';
                }
                $modelObj->updateAll(array('status' => $stsflg), array('id' => $id));
                $processStatus = 'success';
                $msg = 'Status updated successfully';
            } else if (isset($dataParams['actname']) && ($dataParams['actname'] == 'delete')) {
                $modelObj->delete($id);
                $processStatus = 'success';
                $msg = 'Record deleted successfully';
            } else {
                $processStatus = 'error';
                $msg = 'Please try again.';
            }
        }
        $actStatus = array('status' => $processStatus, 'msg' => $msg);
        return $actStatus;
    }

    public function commonList($model, $conditions = array(), $fields = array(), $order = array(), $type = 'list') {
        $modelObj = ClassRegistry::init($model);
        $options = array();
        if (count($fields) > 0) {
            $options['fields'] = $fields;
        }
        if (count($conditions) > 0) {
            $options['conditions'] = $conditions;
        }
        if (count($order) > 0) {
            $options['order'] = $order;
        }
        return $modelObj->find($type, $options);
    }
    
    public function processData($inputArr){        
        $outputArr = array();        
        if(count($inputArr) > 0){            
            foreach($inputArr as $arr){                
                $outputArr[] = current($arr);
            }
        }        
        return $outputArr;
    }
    
    public function statusCode($code, $statusCodes){
        $reponsestatus = array(
             'errorStatus' => 'true',
             'statusCode' => $code,
             'msg' => $statusCodes[$code]
         );        
        return $reponsestatus;
    }
    
    public function missingParameter($code, $invalidFields){        
        $reponsestatus = array(
            'errorStatus' => 'true',
            'statusCode' => 700,
            'msg' => 'Missing required parameter ' . implode(', ', $invalidFields)
        );
        return $reponsestatus;
    }
    
    public function isRecordExist($model, $conditions = array(), $fields = array()) {
        $modelObj = ClassRegistry::init($model);
        $options = array();
        if (count($fields) > 0) {
            $options['fields'] = $fields;
        }
        if (count($conditions) > 0) {
            $options['conditions'] = $conditions;
        }
        if (count($order) > 0) {
            $options['order'] = $order;
        }
        return $modelObj->find($type, $options);
    }
    
    public function isValidNumber($inputVal){        
        $isValid = TRUE;
        if (!is_numeric( $inputVal ) ) {
            $isValid = FALSE;
        }
        return $isValid;
    }
    
    public function isValidMobile($inputVal){        
        $isValid = TRUE;
        $mobileregex = "/^[6-9][0-9]{9}$/" ;  
        if (preg_match($mobileregex, $inputVal) !== 1) {
            $isValid = FALSE;
        }
        return $isValid;
    }
    
    public function isValidLatLong($inputVal) {    
     $isValid = TRUE;
        $latlongregex = "^[+-]?\d+\.\d+, ?[+-]?\d+\.\d+$" ;  
        if (preg_match($latlongregex, $inputVal) !== 1) {
            $isValid = FALSE;
        }
        return $isValid;
    }
    
    public function isValidText($inputVal) {
        $isValid = TRUE;
        $textregex = "/^[a-z0-9 .\-]+$/i" ;  
        if (preg_match($textregex, $inputVal) !== 1) {
            $isValid = FALSE;
        }
        return $isValid;
    }
        
    public function isValidEmail($inputVal) {
        $isValid = TRUE;
        if (filter_var($inputVal, FILTER_VALIDATE_EMAIL) !== 1) {
            $isValid = FALSE;
        }
        return $isValid;
    }
    
    public function cleanInputValue($key, $dataFull, $type) {
        
        return isset($dataFull[$key]) ?  trim($dataFull[$key]) : $type;
    }
    
}
