<?php

App::import('AppController', 'Controller');

class CountriesController extends AppController {

    public $name = 'Countries';
    public $uses = array('Country');
    public $helper = array('Html', 'Session', 'Paginator');
    public $components = array('Session', 'Paginator','CommonCmp','Flash');
    public $paginate = array('limit' => 20, 'order' => array('Country.countryName' => 'asc'));
    public $user_id = '';
    public $logintype = '';

    public function beforeFilter() {
        parent::beforeFilter();
        $this->logintype = $this->Session->read('logintype');
    }

    public function managecountries() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        }else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $this->set('title_for_layout', 'Administrator || Manage Country');
            $conditions = array();
            $searchkey = '';
            if (isset($this->request->data['Country']['searchkey']) && ($this->request->data['Country']['searchkey'] != '')) {
                $searchkey = $this->request->data['Country']['searchkey'];
                $conditions['OR'] = array(
                    'Country.countryName LIKE' => "%$searchkey%"
                );
            }

            $this->paginate['conditions'] = $conditions;
            $this->set('searchkey', $searchkey);

            $this->Paginator->settings = $this->paginate;
            $data = $this->Paginator->paginate('Country');
            $this->set('data', $data);
        }
    }

    public function addCountry() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        }else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $this->set('title_for_layout', 'Administrator || Add Country');
        }
    }

    public function editCountry() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        }else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $this->set('title_for_layout', 'Administrator || Update Country');
            $rid = $this->request->query('id');
            if (!empty($rid) && ($rid != '')) {
                $this->Country->id = $rid;
                $this->request->data = $this->Country->read();
            } else {
                $this->redirect('managecountries');
            }
        }
    }

    public function saveCountry() {
        if (!empty($this->request->data)) {
            $conditions = array(
                'countryName' => $this->request->data['Country']['countryName']
            );
            $msg = 'Country added successfully.';
            if (isset($this->request->data['Country']['id']) && ($this->request->data['Country']['id'] != '')) {
                $conditions['id !='] = $this->request->data['Country']['id'];
                $msg = 'Country updated successfully.';
            }
            $checkexist = $this->Country->find('count', array(
                'conditions' => $conditions
            ));
            if ($checkexist <= 0) {
                $this->Country->create(); //pr($this->request->data);die;            					 					
                if ($this->Country->save($this->request->data)) {
                    $this->Flash->success($msg);
                    $this->redirect('managecountries');
                } else {
                    $this->Flash->warning('Please fill all fields.');
                    $this->redirect('managecountries');
                }
            } else {
                $this->Flash->warning('Country already exists.');
                $this->redirect('managecountries');
            }
        }
    }

    public function checkduplicate() {
        $this->layout = false;
        if (!empty($this->request->data)) {
            $conditions = array(
                $this->request->data['colname'] => $this->request->data['colvalue']
            );
            if (isset($this->request->data['id']) && ($this->request->data['id'] > 0 )) {
                $conditions['id !='] = $this->request->data['id'];
            }
            $checkexist = $this->Country->find('count', array(
                'conditions' => $conditions
            ));
            if ($checkexist <= 0) {
                echo "ACCEPTED";
                die;
            } else {
                echo "ALREADY";
                die;
            }
        }
    }
    
    public function groupaction() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        }else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $querydata = $this->request->query;
            $statusArr = $this->CommonCmp->groupActions('Country', $querydata);         
            $status = isset($statusArr['status'])?$statusArr['status']:'error';
            $msg = isset($statusArr['msg'])?$statusArr['msg']:'Technical error please try after sometime.';
            $this->Flash->$status($msg);
            $this->redirect($this->referer());
        }
    }

}
