<?php

App::import('AppController', 'Controller');
App::import('Vendor', 'PHPExcel', array('file' => 'PHPExcel/Classes/PHPExcel.php'));

class DealersController extends AppController {

    public $name = 'Dealers';
    public $uses = array('Dealer','Pincode');
    public $helper = array('Html', 'Session', 'Paginator');
    public $components = array('Session', 'Paginator', 'Flash', 'CommonCmp');
    public $paginate = array('limit' => 20, 'order' => array('Dealer.company_name' => 'asc'));
    public $user_id = '';
    public $logintype = '';
    public $sheetCols = array();

    public function beforeFilter() {
        parent::beforeFilter();
        $this->logintype = $this->Session->read('logintype');
        $this->sheetCols = array('Company Name', 'Contact Name', 'Latlong', 'House No', 'Street1', 'Street2', 'Street3', 'Street4', 'District', 'Pincode', 'Postal Code', 'City', 'Region', 'Country', 'Mobile No', 'Landline No', 'Loyality Status','EXP/MBO/NPO');
    }

    public function managedealers() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        } else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $this->set('title_for_layout', 'Administrator || Manage Dealers');
            $conditions = array();
            $searchkey = '';
            if (isset($this->request->data['Dealer']['searchkey']) && ($this->request->data['Dealer']['searchkey'] != '')) {
                $searchkey = trim($this->request->data['Dealer']['searchkey']);
                $conditions['OR'] = array(
                    'Dealer.sap_id LIKE' => "%$searchkey%",
                    'Dealer.company_name LIKE' => "%$searchkey%",
                    'Dealer.contact_name LIKE' => "%$searchkey%",
                    'Dealer.dealer_latlong LIKE' => "%$searchkey%",
                    'Dealer.phone_mobile LIKE' => "%$searchkey%"
                );
            }
            $this->paginate['conditions'] = $conditions;
            $this->set('searchkey', $searchkey);
            $this->Paginator->settings = $this->paginate;
            $data = $this->Paginator->paginate('Dealer');
            $this->set('data', $data);

        }
    }

    public function adddealer() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        } else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $this->set('title_for_layout', 'Administrator || Add Dealer');
            }
            $dealerList = $this->CommonCmp->commonList('Pincode',array('Pincode.status'=>'true'),array('Pincode.pincode_code','Pincode.pincode_code'),array('Pincode.pincode_code'=>'ASC'),'list');
            
            $this->set('dealerList',$dealerList);            
            
        
    }

    public function editdealer() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        } else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $this->set('title_for_layout', 'Administrator || Update Dealer');
            $rid = $this->request->query('id');
            if (!empty($rid) && ($rid != '')) {
                $this->Dealer->id = $rid;
                $this->request->data = $this->Dealer->read();
            } else {
                $this->redirect('managedealers');
            }
            $dealerList = $this->CommonCmp->commonList('Pincode',array('Pincode.status'=>'true'),array('Pincode.pincode_code','Pincode.pincode_code'),array('Pincode.pincode_code'=>'ASC'),'list');
            
            $this->set('dealerList',$dealerList); 
        }
    }

    public function importdealer() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        } else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $this->set('title_for_layout', 'Administrator || Import Dealers');
        }
    }

    public function processfile() {
        ini_set('max_execution_time', 600);   
        ini_set('memory_limit','16M');

        $objPHPExcel = new PHPExcel();
        if (isset($this->request->data['Dealer']['filename']["name"]) && ($this->request->data['Dealer']['filename']["name"] != '')) {
            $upload_dir = FILE_UPLOAD_PATH;
            $original = explode('.', $this->request->data['Dealer']['filename']["name"]);
            $extension = array_pop($original);
            $newname = date('YmdHis') . '.' . $extension;
            if (file_exists($upload_dir . $newname)) {
                unlink($upload_dir . $newname);
            }
            if (move_uploaded_file($this->request->data['Dealer']['filename']["tmp_name"], $upload_dir . $newname)) {
                $insertData['Dealer'] = array();
                $updateData['Dealer'] = array();
                $object = PHPExcel_IOFactory::load($upload_dir . $newname);
                foreach ($object->getWorksheetIterator() as $worksheet) {
                    $highestRow = $worksheet->getHighestRow();
                    $highestColumn = $worksheet->getHighestColumn();
                    if (!$this->validateSheetCols($worksheet, 1)) {
                        $invaliCols = implode(',', $this->Session->read('invaliCols'));
                        $this->Flash->notice('Invalid column(s) ' . $invaliCols);
                        $this->redirect('importdealer');
                    }
                    for ($row = 2; $row <= $highestRow; $row++) {
                        $dataSet = $this->excelToArray($worksheet, $row);
                        $company_name = str_replace(" ", "%", strtolower($dataSet['company_name'])) . '%';

                        /* $conditions = array(
                          'Dealer.company_name LIKE' => $company_name,
                          'Dealer.phone_mobile' => $dataSet['phone_mobile'],
                          'Dealer.phone_landline' => $dataSet['phone_landline']
                          ); */

                        $conditions = array(
                            'Dealer.company_name LIKE' => $company_name
                        );
                        $existing = $this->checkExist(array('id', 'company_name'), $conditions);
                        if ($existing) {
                            $dataSet['id'] = $existing['Dealer']['id'];
                            $updateData['Dealer'][] = $dataSet;
                        } else {
                            $insertData['Dealer'][] = $dataSet;
                        }
                    }
                }
                $addedRecords = count($insertData['Dealer']);
                $updatedRecords = count($updateData['Dealer']);

                $this->Dealer->saveAll($insertData['Dealer']);
                $this->Dealer->saveAll($updateData['Dealer']);
                $this->Flash->success($addedRecords . ' record(s) added & ' . $updatedRecords . ' record(s) updated.');
                $this->redirect('importdealer');
            }
        } else {
            $this->Flash->error('Please select file.');
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        }
    }

    private function checkExist($fields, $conditions) {

        return $this->Dealer->find('first', array('fields' => $fields, 'conditions' => $conditions));
    }

    private function excelToArray($worksheet, $row) {

        $company_name = $worksheet->getCellByColumnAndRow(0, $row)->getValue();
        $contact_name = $worksheet->getCellByColumnAndRow(1, $row)->getValue();
        $latlong = $worksheet->getCellByColumnAndRow(2, $row)->getValue();
        $house_no = $worksheet->getCellByColumnAndRow(3, $row)->getValue();
        $street1 = $worksheet->getCellByColumnAndRow(4, $row)->getValue();
        $street2 = $worksheet->getCellByColumnAndRow(5, $row)->getValue();
        $street3 = $worksheet->getCellByColumnAndRow(6, $row)->getValue();
        $street4 = $worksheet->getCellByColumnAndRow(7, $row)->getValue();        
        $district = $worksheet->getCellByColumnAndRow(8, $row)->getValue();
        $pincode_id = $worksheet->getCellByColumnAndRow(9, $row)->getValue();
        $postal_code = $worksheet->getCellByColumnAndRow(10, $row)->getValue();
        $city = $worksheet->getCellByColumnAndRow(11, $row)->getValue();
        $region = $worksheet->getCellByColumnAndRow(12, $row)->getValue();
        $country = $worksheet->getCellByColumnAndRow(13, $row)->getValue();
        $phone_mobile = $worksheet->getCellByColumnAndRow(14, $row)->getValue();
        $phone_landline = $worksheet->getCellByColumnAndRow(15, $row)->getValue();
        $loyalty_status = $worksheet->getCellByColumnAndRow(16, $row)->getValue();
        $exp_mbo_status = $worksheet->getCellByColumnAndRow(17, $row)->getValue();
       
        $data = array(
            'company_name' => $company_name,
            'contact_name' => $contact_name,
            'dealer_latlong' => $latlong,
            'house_no' => $house_no,
            'street1' => $street1,
            'street2' => $street2,
            'street3' => $street3,
            'street4' => $street4,
            'district' => $district,
            'pincode_id' => $pincode_id,
            'postal_code' => $postal_code,
            'city' => $city,
            'region' => $region,
            'country' => $country,
            'phone_mobile' => $phone_mobile,
            'phone_landline' => $phone_landline,
            'loyalty_status' => trim($loyalty_status),
            'exp_mbo_status' => $exp_mbo_status
        );
        return $data;
    }

    private function validateSheetCols($worksheet, $row) {
        $isValid = true;
        $invaliCols = array();
        foreach ($this->sheetCols as $key => $defineColName) {
            $sheetColName = $worksheet->getCellByColumnAndRow($key, $row)->getValue();
            if ($this->removeSpaces($defineColName) != $this->removeSpaces($sheetColName)) {
                $invaliCols[] = $sheetColName;
            }
        }
        if (count($invaliCols) > 0) {
            $this->Session->write('invaliCols', $invaliCols);
            $isValid = false;
        }
        return $isValid;
    }

    private function removeSpaces($string) {
        return strtolower(preg_replace('/\s+/', '', $string));
    }

    public function groupaction() {
        if ($this->logintype == '') {
            $this->Flash->warning(NOT_LOGGEDIN_MSG);
            $this->redirect(array('controller' => 'admins', 'action' => 'login'));
        } else if ($this->logintype != 'ADMIN') {
            $this->Flash->warning(PERMISSION_DENIDE);
            $this->redirect(array('controller' => 'users', 'action' => 'dashboard'));
        } else {
            $querydata = $this->request->query;
            $statusArr = $this->CommonCmp->groupActions('Dealer', $querydata);
            $status = isset($statusArr['status']) ? $statusArr['status'] : 'error';
            $msg = isset($statusArr['msg']) ? $statusArr['msg'] : 'Technical error please try after sometime.';
            $this->Flash->$status($msg);
            $this->redirect($this->referer());
        }
    }

    public function changeLoyaltyStatus() {

        if ($this->request->is('ajax')) {

            $rStatus = 'fail';

            $status = $this->Dealer->updateAll(array('Dealer.loyalty_status' => "'" . $this->request->data['status'] . "'"), array('id' => $this->request->data['dealerId']));

            if ($status) {
                $rStatus = 'success';
            }
            echo $rStatus;
            die;
        }
    }

}
