<?php

App::uses('AppController', 'Controller');

class MapsController extends AppController {

    public $uses = array('User', 'Dealer', 'Pincode', 'District', 'Region', 'Zone');
    public $helper = array('Html', 'Session');
    public $components = array('Session', 'Flash', 'CommonCmp');
    public $logintype = '';
    public $userid = '';
    public $layout = 'front';
    public $designation = '';
    public $accessZones = array();
    public $accessRegion = array();
    public $accessDistrict = array();

    public function beforeFilter() {
        parent::beforeFilter();
        $this->logintype = $this->Session->read('logintype');
        $this->userid = $this->Session->read('user_id');
        $this->designation = $this->Session->read('designation');
        $this->accessZones = $this->Session->read('accessZones');
        $this->accessRegion = $this->Session->read('accessRegion');
        $this->accessDistrict = $this->Session->read('accessDistrict');
    }

    public function home() {
        if ($this->logintype != '') {
            if ($this->logintype == 'ADMIN') {
                $this->Flash->warning(PERMISSION_DENIDE);
                $this->redirect(array('controller' => 'admins', 'action' => 'dashboard'));
            } else {
                $accessZones = $this->Session->read('accessZones');
                $accessRegion = $this->Session->read('accessRegion');
                $accessDistrict = $this->Session->read('accessDistrict');

                $zoneList = $this->CommonCmp->commonList('Zone', array('status' => 'true'), array(), array('zone_name' => 'ASC'), $type = 'all');

                $regionList = array();
                if (count($accessRegion) > 0) {
                    $regionList = $this->CommonCmp->commonList('Region', array('status' => 'true', 'region_code' => $accessRegion), array('region_code', 'region_name'), array('region_name' => 'ASC'), $type = 'list');
                }

                $regionList = array();
                if (count($accessRegion) > 0) {
                    $regionList = $this->CommonCmp->commonList('Region', array('status' => 'true', 'region_code' => $accessRegion), array('region_code', 'region_name'), array('region_name' => 'ASC'), $type = 'list');
                }


                $territoryList = array();
                if (count($accessDistrict) > 0) {
                    $territoryList = $this->CommonCmp->commonList('District', array('status' => 'true', 'district_code' => $accessDistrict), array('district_code', 'district_code'), array('district_code' => 'ASC'), $type = 'list');
                }

                $this->set('zoneList', $zoneList);
                $this->set('regionList', $regionList);
                $this->set('territoryList', $territoryList);
            }
        } else {
            $this->redirect(array('controller' => 'users', 'action' => 'login'));
        }
    }

    public function region_details() {
        $this->layout = false;
        $this->autoRender = false;
        $list = array();
        if ($this->request->is('ajax') && isset($this->request->data['zone_code'])) {
            if (is_array($this->request->data['zone_code'])) {
                $this->request->data['zone_code'] = array_values($this->request->data['zone_code']);
            } else if (isset($this->request->data['passtype']) && $this->request->data['zone_code'] != '') {
                $this->request->data['zone_code'] = array_values(explode(',', $this->request->data['zone_code']));
            }

            $conditions = array('zone_id' => $this->request->data['zone_code']);
            if (count($this->accessRegion) > 0) {
                $conditions['region_code'] = $this->accessRegion;
            }
            $conditions['status']='true';
            $listData = $this->CommonCmp->commonList('Region', $conditions, array(), array('region_name' => 'ASC'), $type = 'all');
            if (count($listData) > 0) {
                foreach ($listData as $dataArr) {
                    $list[] = $dataArr['Region'];
                }
            }
        }
        echo json_encode($list);
        exit();
    }

    public function district_details() {
        $this->layout = false;
        $this->autoRender = false;
        $list = array();
        if ($this->request->is('ajax') && isset($this->request->data['region_code'])) {
            if (is_array($this->request->data['region_code'])) {
                $this->request->data['region_code'] = array_values($this->request->data['region_code']);
            }
            $conditions = array('region_id' => $this->request->data['region_code']);
            if (count($this->accessDistrict) > 0) {
                $conditions['district_code'] = $this->accessDistrict;
            }
            $conditions['status']='true';    
            $listData = $this->CommonCmp->commonList('District', $conditions, array(), array('district_name' => 'ASC'), $type = 'all');
            if (count($listData) > 0) {
                foreach ($listData as $dataArr) {
                    $list[] = $dataArr['District'];
                }
            }
        }
        echo json_encode($list);
        exit();
    }

    public function city_rural_details() {
        $this->layout = false;
        $this->autoRender = false;
        $list = array();
        if ($this->request->is('ajax') && isset($this->request->data['district_id'])) {
            if (is_array($this->request->data['district_id'])) {
                $this->request->data['district_id'] = array_values($this->request->data['district_id']);
            }
            $conditions = array('district_id' => $this->request->data['district_id']);
            if (isset($this->request->data['type']) && $this->request->data['type'] > 0) {
                $conditions['type'] = $this->request->data['type'];
            }
            $conditions['status']='true';
            $listData = $this->CommonCmp->commonList('Area', $conditions, array(), array('name' => 'ASC'), $type = 'all');
            if (count($listData) > 0) {
                foreach ($listData as $dataArr) {
                    $list[] = $dataArr['Area'];
                }
            }
        }
        echo json_encode($list);
        exit();
    }

    public function territory_details() {
        $this->layout = false;
        $this->autoRender = false;
        $list = array();
        if ($this->request->is('ajax') && isset($this->request->data['district_id'])) {
            $conditions = array('status'=>'true');
            if (isset($this->request->data['district_id']) && count($this->request->data['district_id']) > 0) {
                $conditions['district_id'] = array_values($this->request->data['district_id']);
            }
            $listData = $this->CommonCmp->commonList('Territory', $conditions, array(), array('territory_code' => 'ASC'), $type = 'all');
            if (count($listData) > 0) {
                foreach ($listData as $dataArr) {
                    $list[] = $dataArr['Territory'];
                }
            }
        }
        echo json_encode($list);
        exit();
    }

    public function pincode_details() {
        $this->layout = false;
        $this->autoRender = false;
        $list = array();
        if ($this->request->is('ajax') && isset($this->request->data['district_code'])) {
            if (is_array($this->request->data['district_code'])) {
                $this->request->data['district_code'] = array_values($this->request->data['district_code']);
            }
            $conditions = array('district_id' => $this->request->data['district_code']);
            if (isset($this->request->data['type']) && $this->request->data['type'] > 0) {
                $conditions['type'] = $this->request->data['type'];
            }
            if (isset($this->request->data['city_rural_id']) && count($this->request->data['city_rural_id']) > 0) {
                $conditions['city_rural_id'] = $this->request->data['city_rural_id'];
            }

            if (isset($this->request->data['territory_id']) && count($this->request->data['territory_id']) > 0) {
                $conditions['territory_id'] = $this->request->data['territory_id'];
            }

            $listData = $this->CommonCmp->commonList('Pincode', $conditions, array(), array('pincode_code' => 'ASC'), $type = 'all');
            if (count($listData) > 0) {
                foreach ($listData as $dataArr) {
                    $list[] = $dataArr['Pincode'];
                }
            }
        }
        echo json_encode($list);
        exit();
    }

    public function fetch_markers() {
        $this->layout = false;
        $this->autoRender = false;
        $resultArr = array();
        if ($this->request->is('ajax') && isset($this->request->data['marker_detail'])) {
            $reqData = $this->request->data;
            $code = $reqData['marker_detail'];
            $where = array();
            if ($code != '') {
                $code_data = explode(',', $code);
                $code_name = $code_data[0];
                $code_value = $code_data[1];
                $filters = explode('_', $code_name);
                $modelName = ucfirst($filters[0]);
                if (isset($filters[0]) && !is_numeric($modelName)) {
                    $where = array($modelName . '.' . 'status' => 'true', $modelName . '.' . $code_name => $code_value);
                    if (isset($reqData['activity_status']) && count($reqData['activity_status']) > 0) {
                        $where['Dealer.exp_mbo_status'] = $reqData['activity_status'];
                    }                    
                }
                
                   if (isset($reqData['city_rural_id']) && count($reqData['city_rural_id']) > 0) {
                        $where['Pincode.city_rural_id'] = $reqData['city_rural_id'];
                    }                    
                    if (isset($reqData['territory_id']) && count($reqData['territory_id']) > 0) {
                        $where['Pincode.territory_id'] = $reqData['territory_id'];
                    }
                    if (isset($reqData['district_id']) && count($reqData['district_id']) > 0) {
                        $where['Pincode.district_id'] = $reqData['district_id'];
                    }
            }

            $fields = array('Dealer.phone_mobile,Dealer.street1,Dealer.company_name,Dealer.contact_name,Dealer.dealer_latlong,Dealer.pincode_id,District.district_name,Region.region_name,Zone.zone_name,Zone.zone_population,Pincode.pincode_code,Pincode.pincode_population,Dealer.exp_mbo_status');

            $resultArray = $this->Dealer->find('all', array(
                'fields' => $fields,
                'conditions' => $where,
                'joins' => array(
                    array(
                        'table' => 'pincodes',
                        'alias' => 'Pincode',
                        'foreignKey' => false,
                        'conditions' => array('Pincode.pincode_code = Dealer.pincode_id')
                    ),
                    array(
                        'table' => 'districts',
                        'alias' => 'District',
                        'foreignKey' => false,
                        'conditions' => array('District.district_code = Pincode.district_id')
                    ),
                    array(
                        'table' => 'regions',
                        'alias' => 'Region',
                        'foreignKey' => false,
                        'conditions' => array('Region.region_code = District.region_id')
                    ),
                    array(
                        'table' => 'zones',
                        'alias' => 'Zone',
                        'foreignKey' => false,
                        'conditions' => array('Zone.zone_code = Region.zone_id')
                    )
                ),
                'limit' => 1000
            ));
            
            if (count($resultArray) > 0) {
                foreach ($resultArray as $data) {
                    $mergeArr = $data['Dealer'] + $data['District'] + $data['Region'] + $data['Zone'] + $data['Pincode'];
                    $resultArr[] = $mergeArr;
                }
            }
        }
        
        echo json_encode($resultArr);
        exit();
    }

    public function population_details() {
        $this->layout = false;
        $this->autoRender = false;
        $result = array();
        $color_code = '#8E44AD';
        if ($this->request->is('ajax') && isset($this->request->data['place_code'])) {
            $code = $this->request->data['place_code'];
            $code_data = explode(',', $code);
            $code_name = $code_data[0];
            $code_value = $code_data[1];
            $filters = explode('_', $code_name);
            $modelName = ucfirst($filters[0]);

            $populationData = $this->$modelName->find('all', array('fields' => array('SUM(' . $filters[0] . '_population) as population'), 'conditions' => array($modelName . '.' . $code_name => $code_value)));

            $x = isset($populationData[0][0]['population']) ? (int) $populationData[0][0]['population'] : 0;

            if ($modelName == 'Zone') {
                $postFix = 'CR';
            } else if ($modelName == 'Region') {
                $postFix = 'TWOLAC';
            } else if ($modelName == 'District') {
                $postFix = 'LAC';
            } else {
                $postFix = 'THOUS';
            }

            if ($x >= 0 && $x <= constant('RANGE_ONE_' . $postFix)) {
                $color_code = '#CD5C5C';
            } else if ($x > constant('RANGE_ONE_' . $postFix) && $x <= constant('RANGE_TWO_' . $postFix)) {
                $color_code = '#008080';
            } else if ($x > constant('RANGE_TWO_' . $postFix) && $x <= constant('RANGE_THREE_' . $postFix)) {
                $color_code = '#800000';
            } else if ($x > constant('RANGE_TWO_' . $postFix) && $x <= constant('RANGE_FOUR_' . $postFix)) {
                $color_code = '#808000';
            } else {
                $color_code = '#8E44AD';
            }
        }
        echo json_encode($color_code);
        exit();
    }

    public function exp_details() {
        $this->layout = false;
        $this->autoRender = false;
        $countResult = 0;
        if ($this->request->is('ajax') && isset($this->request->data['place_code'])) {
            $countResult = $this->getExpMbo($this->request->data, 'EXP');
        }
        echo $countResult;
        exit();
    }

    public function mbo_details() {
        $this->layout = false;
        $this->autoRender = false;
        $countResult = 0;
        if ($this->request->is('ajax') && isset($this->request->data['place_code'])) {
            $countResult = $this->getExpMbo($this->request->data, 'MBO');
        }
        echo $countResult;
        exit();
    }

    public function na_details() {
        $this->layout = false;
        $this->autoRender = false;
        $countResult = 0;
        if ($this->request->is('ajax') && isset($this->request->data['place_code'])) {
            $countResult = $this->getExpMbo($this->request->data, 'NOT ACTIVE');
        }
        echo $countResult;
        exit();
    }

    private function getExpMbo($data, $type) {
        $where = array();
        if (isset($data['pincode']) && count($data['pincode']) > 0) {
            $where = array('Dealer.exp_mbo_status' => $type, 'Dealer.' . 'pincode_id' => $data['pincode']);
            $this->Dealer->virtualFields['total'] = 'COUNT(Dealer.exp_mbo_status)';
            $expMboData = $this->Dealer->find('all', array(
                'fields' => array('total'),
                'conditions' => $where
            ));
        } else {
            $code = $data['place_code'];
            $code_data = explode(',', $code);
            $code_name = $code_data[0];
            $code_value = $code_data[1];
            $filters = explode('_', $code_name);
            $modelName = ucfirst($filters[0]);
            if (isset($filters[0])) {
                $where = array('Dealer.exp_mbo_status' => $type, $modelName . '.' . 'status' => 'true', $modelName . '.' . $code_name => $code_value);
            }

            $this->Dealer->virtualFields['total'] = 'COUNT(Dealer.exp_mbo_status)';

            $expMboData = $this->Dealer->find('all', array(
                'fields' => array('total'),
                'conditions' => $where,
                'joins' => array(
                    array(
                        'table' => 'pincodes',
                        'alias' => 'Pincode',
                        'foreignKey' => false,
                        'conditions' => array('Pincode.pincode_code = Dealer.pincode_id')
                    ),
                    array(
                        'table' => 'districts',
                        'alias' => 'District',
                        'foreignKey' => false,
                        'conditions' => array('District.district_code = Pincode.district_id')
                    )
                )
            ));
        }
        return isset($expMboData[0]['Dealer']['total']) ? (int) $expMboData[0]['Dealer']['total'] : 0;
    }

    public function legends() {

        if ($this->request->is('ajax') && isset($this->request->data['place_code'])) {
            $modelName = $this->request->data['place_code'];
            if ($modelName == 'Zone') {
                $postFix = 'CR';
            } else if ($modelName == 'Region') {
                $postFix = 'TWOLAC';
            } else if ($modelName == 'Pincode') {               
                $postFix = 'THOUS';
            }

            $ranges = array(
                '#CD5C5C_0_' . constant('RANGE_ONE_' . $postFix),
                '#008080_' . (constant('RANGE_ONE_' . $postFix) + 1) . '_' . constant('RANGE_TWO_' . $postFix),
                '#472bd8_' . (constant('RANGE_TWO_' . $postFix) + 1) . '_' . constant('RANGE_THREE_' . $postFix),
                '#800000_' . (constant('RANGE_THREE_' . $postFix) + 1) . '_' . constant('RANGE_FOUR_' . $postFix),
                '#8E44AD_Other_Other'
            );

            echo json_encode($ranges);
            exit;
        }
    }

}
