<?php

/*
 * Author      : Compare Infobase Dev Team
 * Created on  : 18-12-2018 11:10 AM 
 * Modified on : 18-12-2018 11:10 AM 
 * Objective   : Users controler class written for the users related Apis
 */

class UsersController extends ApisAppController {

    public $name = 'Users';
    public $uses = array('User');
    public $components = array('Email', 'ValidationCmp');

    public function beforeFilter() {
        parent::beforeFilter();
        $this->layout = false;
        $this->autoRender = false;
    }

    public function beforeRender() {
        parent::beforeRender();
        $this->autoRender = false;
    }

    public function login() {

        $reponsestatus = array();

        $dataFull = $this->request->input('json_decode', true);

        $invalidFields = $this->ValidationCmp->validateParams(array('username', 'password'), $dataFull);

        if (!$this->ValidationCmp->allowMethod($this->request, 'post')) {
            $reponsestatus = array(
                'error' => 'true',
                'msg' => 'Method Not Allowed'
            );
        } else if (count($invalidFields) > 0) {
            $reponsestatus = array(
                'error' => 'true',
                'msg' => 'Missing required parameters ' . implode(', ', $invalidFields)
            );
        } else {
            $where = array(
                'User.designation !=' => 'admin',
                'BINARY(User.name)' => $dataFull['username']
            );
            
            try {
                $logindata = $this->User->find('first', array(
                    'conditions' => $where,
                    'fields' => array('id', 'email', 'name', 'designation', 'status', 'password')
                ));

                if (!empty($logindata)) {
                    $logindata = current($logindata);
                    if ($logindata['password'] != base64_encode($dataFull['password'])) {
                        $reponsestatus = array(
                            'error' => 'true',
                            'msg' => 'You have entered incorrect password.'
                        );
                    } else if ($logindata['status'] !== '1') {
                        $reponsestatus = array(
                            'error' => 'true',
                            'msg' => 'Your account is temporarily blocked for login'
                        );
                    } else {
                        unset($logindata['password']);
                        $reponsestatus = array(
                            'error' => 'false',
                            'msg' => 'You have been successfully logged in.',
                            'userprofile' => $logindata
                        );
                    }
                } else {
                    $reponsestatus = array(
                        'error' => 'true',
                        'msg' => 'You have entered invalid login credentials'
                    );
                }
            } catch (Exception $e) {
                $reponsestatus = array(
                    'error' => 'true',
                    'msg' => 'Internal Server Error'
                );
            }
        }
        echo $this->ValidationCmp->outputJson($reponsestatus);
    }

}
