<?php
/**
 * CakePHP(tm) : Rapid Development Framework (https://cakephp.org)
 * Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 *
 * Licensed under The MIT License
 * For full copyright and license information, please see the LICENSE.txt
 * Redistributions of files must retain the above copyright notice.
 *
 * @copyright     Copyright (c) Cake Software Foundation, Inc. (https://cakefoundation.org)
 * @link          https://cakephp.org CakePHP(tm) Project
 * @package       app.View.Layouts
 * @since         CakePHP(tm) v 0.10.0.1076
 * @license       https://opensource.org/licenses/mit-license.php MIT License
 */
?>
<!DOCTYPE html>
<html>
    <head> 
        <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
        <?php echo $this->Html->charset(); ?>
        <title><?php echo $this->fetch('title'); ?></title>
        <meta name="keyword" content="<?php echo isset($keyword_for_layout) ? $keyword_for_layout : ''; ?>">
        <meta name="description" content="<?php echo isset($description_for_layout) ? $description_for_layout : ''; ?>">
        <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
        <link rel="shortcut icon" type="image/x-icon" href="<?php echo $this->webroot; ?>favicon.ico" />

        <!-- bootstrap & fontawesome -->
        <link rel="stylesheet" href="<?php echo $this->webroot; ?>css/bootstrap.min.css" />
        <link rel="stylesheet" href="<?php echo $this->webroot; ?>font-awesome/4.5.0/css/font-awesome.min.css" />

        <!-- page specific plugin styles -->

        <!-- text fonts -->
        <link rel="stylesheet" href="<?php echo $this->webroot; ?>css/fonts.googleapis.com.css" />

        <!-- ace styles -->
        <link rel="stylesheet" href="<?php echo $this->webroot; ?>css/ace.min.css" class="ace-main-stylesheet" id="main-ace-style" />
        <link rel="stylesheet" href="<?php echo $this->webroot; ?>css/flush_message.css" />
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.3/css/select2.min.css"/>
        <link rel="stylesheet" href="https://select2.github.io/select2-bootstrap-theme/css/select2-bootstrap.css"/>
        <script src="<?php echo $this->webroot; ?>js/jquery-2.1.4.min.js"></script>
        <script src="<?php echo $this->webroot; ?>js/jquery.validate.min.js"></script>
        <script src="<?php echo $this->webroot; ?>js/form-validation.js?v=1.0.1"></script>
        <script src="<?php echo $this->webroot; ?>js/select2.min.js"></script>
        <script type="text/javascript">
            jQuery(function ($) {
                var msg = '<?php echo $this->Flash->render(); ?>';
                if (msg != '') {
                    demo.showNotification('top', 'center', msg);
                }
            });
            $(window).load(function () {
                $('#status').fadeOut();
                $('#preloader').delay(350).fadeOut('slow');
                $('body').delay(350).css({
                    'overflow': 'visible'
                });
            });
        </script>
        <script type="text/javascript">
            if ('ontouchstart' in document.documentElement)
                document.write("<script src='<?php echo $this->webroot; ?>js/jquery.mobile.custom.min.js'>" + "<" + "/script>");
        </script>
        <script src="<?php echo $this->webroot; ?>js/bootstrap.min.js"></script>
        <script src="<?php echo $this->webroot; ?>js/ace.min.js"></script>

        <?php
        echo $this->Html->script('customscript');
        echo $this->Html->script('bootstrap-notify');
        echo $this->Html->script('demo');
        ?>
    </head>
    <body class="<?php if ($this->action == 'login') {
            echo 'login-layout light-login';
        } else {
            echo 'no-skin';
        } ?>">
        <div id="preloader"><div id="status"><div class="spinner"></div></div></div>
                <?php
                $logintype = $this->Session->read('logintype');
                if ($logintype == 'ADMIN') {
                    echo $this->element('admin-header');
                }
                echo $this->fetch('content');

                if ($logintype != '' && $logintype == 'ADMIN') {
                    echo $this->element('admin-footer');
                }
                ?>
    </body>
</html>
