$(document).ready(function () {
     $("#zone-form").validate({
        rules: {
            'data[Zone][zone_code]': {
                required: true,
                minlength: 2
            },
            'data[Zone][zone_name]': {
                required: true
            },
            'data[Zone][zone_latlong]': {
                required: true
            },
            'data[Zone][zone_population]': {
                required: true
            }
        },
        messages: {
            'data[Zone][zone_code]': {
                required: "Please enter zone code",
                minlength: "Zone code should be at least {0} characters long"
            },
            'data[Zone][zone_name]': {
                required: "Please enter zone name"
            },
            'data[Zone][zone_latlong]': {
                required: "Please enter zone latlong"
            },
            'data[Zone][zone_population]': {
                required: "Please enter zone population"
            }
        },
        submitHandler: function (form) {
            return true;
        }
    });
    
    $("#region-form").validate({
        rules: {
            'data[Region][zone_id]':{
               required: true 
            },
            'data[Region][region_code]': {
                required: true,
                minlength: 2
            },
            'data[Region][region_name]': {
                required: true
            },
            'data[Region][region_latlong]': {
                required: true
            },
            'data[Region][region_population]': {
                required: true
            }
        },
        messages: {
            'data[Region][zone_id]': {
                required: "Please select zone"
            },
            'data[Region][region_code]': {
                required: "Please enter region code",
                minlength: "Region code should be at least {0} characters long"
            },
            'data[Region][region_name]': {
                required: "Please enter region name"
            },
            'data[Region][region_latlong]': {
                required: "Please enter region latlong"
            },
            'data[Region][region_population]': {
                required: "Please enter region population"
            }
        },
        submitHandler: function (form) {
            return true;
        }
    });    
    
    $("#district-form").validate({
        rules: {
            'data[District][zone_id]':{
               required: true 
            },
            'data[District][region_id]':{
               required: true 
            },
            'data[District][district_name]':{
               required: true 
            },   
            'data[District][district_code]': {
                required: true,
                minlength: 2
            },
            'data[District][district_latlong]': {
                required: true
            },
            'data[District][district_latlong]': {
                required: true
            },
            'data[District][district_population]': {
                required: true
            }
        },
        messages: {
            'data[District][zone_id]': {
                required: "Please select zone"
            },
            'data[District][region_id]': {
                required: "Please select region"
            },
            'data[District][district_name]':{
                required: "Please enter district name"
            },
            'data[District][district_code]': {
                required: "Please enter district code",
                minlength: "District code should be at least {0} characters long"
            },
            'data[District][district_latlong]': {
                required: "Please enter district latlong"
            },
            'data[District][district_population]': {
                required: "Please enter district population"
            }
        },
        submitHandler: function (form) {
            return true;
        }
    });
    
    $("#pincode-form").validate({
        rules: {
            'data[Pincode][district_id]':{
               required: true 
            },
            'data[Pincode][pincode_code]':{
               required: true 
            },
            'data[Pincode][pincode_population]':{
               required: true 
            },
            'data[Pincode][pincode_latlong]':{
               required: true 
            }
        },
        messages: {
            'data[Pincode][district_id]': {
                required: "Please select district"
            },
            'data[Pincode][pincode_code]': {
                required: "Please enter pincode"
            },
            'data[Pincode][pincode_population]':{
                required: "Please enter pincode population"
            },
            'data[Pincode][pincode_latlong]':{
               required: "Please enter pincode latlong"
            }
        },
        submitHandler: function (form) {
            return true;
        }
    });  
    
    $("#territoryInputForm").validate({
        rules: {
            'data[Territory][territory_code]':{
               required: true,
               minlength: 2
            },
            'data[Territory][district_id]':{
               required: true 
            },
            'data[Territory][pincode_code]':{
               required: true 
            }
        },
        messages: {
            'data[Territory][territory_code]': {
                required: "Please enter territory code",
                minlength: "Territory Code should be at least {0} characters long"
            },
            'data[Territory][district_id]':{
               required: "Please select district"
            },
            'data[Territory][pincode_code]': {
                required: "Please select pincode"
            }
        },
        submitHandler: function (form) {
            return true;
        }
    });
});
function getRegion(zoneId) {
    var selected = $('#hidden_region_id').val();
    $('#region_id').html('').html('<option value="">Loading</option>');
    if (zoneId !== '') {
        $('#region_id').html('').html('<option value="">Loading</option>');
        $.ajax({
            url: 'loadregionlist',
            type: "POST",
            data: {
                'zone_id': zoneId
            },
            cache: false,
            success: function (data, textStatus, jqXHR) {
                var htmlOptions = '<option value="">Select Region</option>';
                data = $.parseJSON(data);
                $.each(data, function (i, v) {
                    var otpSelected = '';
                    if (selected.trim() === i.trim()) {
                        otpSelected = 'selected';
                    }
                    htmlOptions += "<option value=" + i + " " + otpSelected + ">" + v + "</option>";
                });
                $('#region_id').html('').html(htmlOptions);
            }
        });
    } else {
        $('#region_id').html().html('<option value="">Select Region</option>');
    }
}


function loadpincodes() {
    var selected = '';
    if($('#TerritoryHiddenPincode').length > 0){
       selected = $('#TerritoryHiddenPincode').val();       
       selected = selected.split(',');       
    }
    $('#PincodeList').html('').html('Select Pincode');
    if ($('#district_id').val() !== '') {
        $('#PincodeList').html('').html('Loading...');
        $.ajax({
            url: 'loadpincodelist',
            type: "POST",
            data: {
                'district_id': $('#district_id').val(),
                'city_rural_id': $('#city_rural_id').val()
            },
            cache: false,
            success: function (data, textStatus, jqXHR) {
                var htmlOptions = '';
                data = $.parseJSON(data);
                $.each(data, function (i, v) {
                    var chk = '';
                    if (selected.length > 0 && $.inArray(i, selected) > -1) {
                        chk = 'checked';
                    }
                    htmlOptions += "<span><input " + chk + " type=checkbox onclick=setSelectedPin() value=" + i + " name=data[Territory][pincode_code][] /><label>" + v + "</label></span><br>";
                });
                $('#PincodeList').html('').html(htmlOptions);
            }
        });
    }
}
function loadcityrural(zoneId) {
    var selected = '';
    if($('#TerritoryHiddenCityRuralId').length > 0){
       selected = $('#TerritoryHiddenCityRuralId').val();
    }
    if (zoneId !== '') {
        $('#city_rural_id').html('').html('<option value="">Loading</option>');
        $.ajax({
            url: 'loadcityrural',
            type: "POST",
            data: {
                'district_id': zoneId                
            },
            cache: false,
            success: function (data, textStatus, jqXHR) {
                var htmlOptions = '<option value="">Select City/Rural</option>';
                data = $.parseJSON(data);
                $.each(data, function (i, v) {
                    var otpSelected = '';
                    if (selected !='' && selected.trim() === i.trim()) {
                        otpSelected = 'selected';
                    }
                    htmlOptions += "<option value=" + i + " " + otpSelected + ">" + v + "</option>";
                });
                $('#city_rural_id').html('').html(htmlOptions);
            }
        });
    } else {
        $('#city_rural_id').html('').html('<option value="">Select City/Rural</option>');
    }
}

function setSelectedPin(){   
    var selectPins = [];
    $.each($('#PincodeList input[type=checkbox]:checked'), function(){            
        selectPins.push($(this).val());
    });
    if(selectPins !=''){
        $('#selectedPinList').html('').html(selectPins.join(", "));
    } else {
        $('#selectedPinList').html('').html('Please select atleast one checkbox.');
    }
}
