$(document).ready(function() {
    $('#dealerInputForm input,#zoneInputForm input,#pincodeQuery input','#areaInputForm input,#territoryQuery input').change(function() {
        $(this).removeClass('error_msg');
    });
});

function pincodeQuery() {
    var submitFlag = true;
    if (!validText($('#territory_id'))) {
        submitFlag = false;
    }

    if (!validText($('#pincode'))) {
        submitFlag = false;
    }

    if (!validLatlong($('#pincode_latlong'))) {
        submitFlag = false;
    }

    if (!validPopulation($('#pincode_population'))) {
        submitFlag = false;
    }
    if (submitFlag) {
        $('#pincodeInputForm').submit();
        
     }
    else
     {
        return false;
     }
   
}

function territoryQuery() {
    var submitFlag = true;
    if (!validText($('#area_id'))) {
        submitFlag = false;
    }

    if (!validText($('#territory_code'))) {
        submitFlag = false;
    }

    if (!validLatlong($('#territory_latlong'))) {
        submitFlag = false;
    }

    if (!validPopulation($('#territory_population'))) {
        submitFlag = false;
    }
    if (submitFlag) {
        $('#territoryInputForm').submit();
        
     }
    else
     {
        return false;
     }  
    

}

function areaQuery() {
    var submitFlag = true;

    if (!validText($('#zone_id'))) {
        submitFlag = false;
    }
    if (!validText($('#area_name'))) {
        submitFlag = false;
    }

    if (!validText($('#area_code'))) {
        submitFlag = false;
    }

    if (!validLatlong($('#area_latlong'))) {
        submitFlag = false;
    }

    if (!validPopulation($('#area_population'))) {
        submitFlag = false;
    }
    if (submitFlag) {
        $('#areaInputForm').submit();
        
     }
    else
     {
        return false;
     }  

}

function zoneQuery() {
    var submitFlag = true;
    if (!validText($('#zone_name'))) {
        submitFlag = false;
    }

    if (!validText($('#zone_code'))) {
        submitFlag = false;
    }

    if (!validLatlong($('#zone_latlong'))) {
        submitFlag = false;
    }

    if (!validPopulation($('#zone_population'))) {
        submitFlag = false;
    }
     if (submitFlag) {
        $('#zoneInputForm').submit();
        
     }
    else
     {
        return false;
     }   

}

function processQuery() {
    var submitFlag = true;

    if (!validText($('#company_name'))) {
        submitFlag = false;
    }

    if (!validText($('#contact_name'))) {
        submitFlag = false;
    }

    if (!validLatlong($('#dealer_latlong'))) {
        submitFlag = false;
    }

    if (!validText($('#street1'))) {
        submitFlag = false;
    }

    if (!validPincode($('#pincode_id'))) {
        submitFlag = false;
    }

    if (!validPhone($('#phone_mobile'))) {
        submitFlag = false;
    }

    if (submitFlag) {
        $('#dealerInputForm').submit();
        
    } else {
        return false;
    }
}

function adderror_msg(inpObj) {
    inpObj.addClass('error_msg');
    //inpObj.append("<p style='color:red;float:right;display:block;'>"+msg+"</p>");
}

function clearerror_msg(inpObj) {
    inpObj.removeClass('error_msg');
}

function validText(paramObj) {
    var isValid = true;
    var paramVal = '';
    paramVal = $.trim(paramObj.val());
    if (paramVal == '') {
        isValid = false;
        adderror_msg(paramObj);
    } else if (paramVal != '' && !(/^[a-zA-Z]+[a-zA-Z\s]+$/.test(paramVal))) {
        isValid = false;
        adderror_msg(paramObj);
    } else {
        clearerror_msg(paramObj);
    }
    return isValid;
}

function validPopulation(paramObj) {
    var isValid = true;
    var paramVal = '';
    paramVal = $.trim(paramObj.val());
    if (paramVal == '') {
        isValid = false;
        adderror_msg(paramObj);
    } 
    // else if (paramVal != '' && !("/^[0-9]+$/".match(paramVal))) {
    //     alert("pattern not matched");
    //     isValid = false;
    //     adderror_msg(paramObj);
    // } 
    else 
    {
         clearerror_msg(paramObj);
    }
    return isValid;
}

function validLatlong(paramObj) {
    var isValid = true;
    var paramVal = '';
    var regEx = /^[-]?(([0-8]?[0-9])\.(\d+))|(90(\.0+)?),[-]?((((1[0-7][0-9])|([0-9]?[0-9]))\.(\d+))|180(\.0+)?)$/;
    paramVal = $.trim(paramObj.val());
    if (paramVal == '') {
        isValid = false;
        adderror_msg(paramObj);
    }
     //else if (paramVal != '' && !(regEx.match(paramVal))) {
    //     isValid = false;
    //     adderror_msg(paramObj);
    // }
     else {
        clearerror_msg(paramObj);
    }
    return isValid;
}

function validHouseNo(paramObj) {
    var isValid = true;
    var paramVal = '';
    paramVal = $.trim(paramObj.val());
    if (paramVal == '') {
        isValid = false;
        adderror_msg(paramObj);
    } else if (paramVal != '' && !(/^\d+[a-zA-Z]*$/.match(paramVal))) {
        isValid = false;
        adderror_msg(paramObj);
    } else {
        clearerror_msg(paramObj);
    }
    return isValid;
}

function validPincode(paramObj) {
    var isValid = true;
    var paramVal = '';
    paramVal = $.trim(paramObj.val());
    if (paramVal == '') {
        isValid = false;
        adderror_msg(paramObj);
    } 
    // else if (paramVal != '' && !(/^[1-9][0-9]{5}$/.match(paramVal))) {
    //     isValid = false;
    //     adderror_msg(paramObj);
    // } 
    else {
        clearerror_msg(paramObj);
    }
    return isValid;
}

function validCity(paramObj) {
    var isValid = true;
    var paramVal = '';
    paramVal = $.trim(paramObj.val());
    if (paramVal == '') {
        isValid = false;
        adderror_msg(paramObj);
    } else if (paramVal != '' && !(/^[a-zA-Z]+(?:[\s-][a-zA-Z]+)*$/.match(paramVal))) {
        isValid = false;
        adderror_msg(paramObj);
    } else {
        clearerror_msg(paramObj);
    }
    return isValid;
}

function validPhone(paramObj) {
    var isValid = true;
    var paramVal = '';
    paramVal = $.trim(paramObj.val());
    if (!(/^[6789]\d{9}$/.match(paramVal))) {
        isValid = false;
        adderror_msg(paramObj);
    } else {
        clearerror_msg(paramObj);
    }
    return isValid;
}

function validEmail(paramObj) {
    var isValid = true;
    var paramVal = '';
    paramVal = $.trim(paramObj.val());
    if (!(/^(?=[^@]{2,}@)([\w\.-]*[a-zA-Z0-9_]@(?=.{2,}\.[^.]*$)[\w\.-]*[a-zA-Z0-9]{2,4}\.[a-zA-Z][a-zA-Z\.]*[a-zA-Z])$/.match(paramVal))) {
        isValid = false;
        adderror_msg(paramObj);
    } else {
        clearerror_msg(paramObj);
    }
    return isValid;
}